﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;

namespace bankchurn
{
    class client
    {
        //15634602; 619; France; Female; 42; 2; 0; 1; 1; 1; 101348.88; 1
        //customer_id; credit_score; country; gender; age; tenure; balance; products_number; 
        //credit_card; active_member; estimated_salary; churn

        public int id { get; set; }
        public int score { get; set; }
        public int country { get; set; }
        public int gender { get; set; }
        public int age { get; set; }
        public int tenure { get; set; }
        public double balance { get; set; }
        public int product { get; set; }
        public int card { get; set; }
        public int active { get; set; }
        public double salary { get; set; }
 
        public client(int Id, int Score, int Country, int Gender, int Age, 
            int Tenure, double Balance, int Product, int Card, int Active, double Salary)
        {
            id = Id;
            score = Score;
            country = Country;
            gender = Gender;
            age = Age;
            tenure = Tenure;
            balance = Balance;
            product = Product;
            card = Card;
            active = Active;
            salary = Salary;
        }
    }

    class DataHolder
    {
        Dictionary<string, int> _country = new Dictionary<string, int>();
        Dictionary<string, int> _gender = new Dictionary<string, int>();
        Dictionary<string, int> _product = new Dictionary<string, int>();
        Dictionary<string, int> _card = new Dictionary<string, int>();
        Dictionary<string, int> _active = new Dictionary<string, int>();

        public List<double[]> _inputs = new List<double[]>();
        public List<client> _clients = new List<client>();
        public List<double> _targets = new List<double>();

        public DataHolder()
        {
            _country.Add("France", 0);
            _country.Add("Spain", 1);
            _country.Add("Germany", 2);

            _gender.Add("Male", 0);
            _gender.Add("Female", 1);

            _product.Add("1", 0);
            _product.Add("2", 1);
            _product.Add("3", 2);
            _product.Add("4", 3);

            _card.Add("0", 0);
            _card.Add("1", 1);

            _active.Add("0", 0);
            _active.Add("1", 1);
        }

        public void PrepareBankChurnData()
        {
            string fileName = @"..\..\bankchurn.csv";
            using (StreamReader file = new StreamReader(fileName))
            {
                string line = file.ReadLine(); //skip first line
                while (true)
                {
                    line = file.ReadLine();
                    if (null == line) break;

                    string[] data = line.Split(';');
                    if (12 != data.Length)
                    {
                        Console.WriteLine("Misformatted line {0}", line);
                        Environment.Exit(0);
                    }

                    int id = Int32.Parse(data[0]);
                    int score = Int32.Parse(data[1]);
                    int country = _country[data[2].Trim()];
                    int gender = _gender[data[3].Trim()];
                    int age = Int32.Parse(data[4]);
                    int tenure = Int32.Parse(data[5]);
                    double balance = Double.Parse(data[6]);
                    int product = _product[data[7].Trim()];
                    int card = _card[data[8].Trim()];
                    int active = _active[data[9].Trim()];
                    double salary = Double.Parse(data[10]);

                    double[] input = new double[10];
                    input[0] = score;
                    input[1] = country;
                    input[2] = gender;
                    input[3] = age;
                    input[4] = tenure;
                    input[5] = balance;
                    input[6] = product;
                    input[7] = card;
                    input[8] = active;
                    input[9] = salary;
                    _inputs.Add(input);

                    double target = Double.Parse(data[11]);
                    if (target < 0.1) target = -1.0;

                    _clients.Add(new client(id, score, country, gender, age, tenure, balance, product, card, active, salary));
                    _targets.Add(target);
                }
                file.Close();               
            }
        }
    }
}
