﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace bankchurn
{
    class LinearModel
    {
        public void TestLinearModel(List<double[]> inputs, List<double> targets)
        {
            int size = inputs[0].Length;
            double[,] MTM = new double[size, size];

            for (int i = 0; i < size; ++i)
            {
                for (int j = 0; j < size; ++j)
                {
                    MTM[i, j] = 0.0;
                    for (int k = 0; k < inputs.Count; ++k)
                    {
                        MTM[i, j] += inputs[k][i] * inputs[k][j];
                    }
                }
            }

            double[] MTV = new double[size];
            for (int i = 0; i < size; ++i)
            {
                MTV[i] = 0.0;
                for (int k = 0; k < inputs.Count; ++k)
                {
                    MTV[i] += inputs[k][i] * targets[k];
                }
            }

            //regularization
            //double trace = 0.0;
            //for (int i = 0; i < size; ++i)
            //{
            //    trace += MTM[i, i];
            //}
            //trace /= size;
            //trace /= 1000;
            //for (int i = 0; i < size; ++i)
            //{
            //    MTM[i, i] += trace;
            //}

            //Solution
            double[] solution = new double[size];
            Cholesky ch = new Cholesky();
            ch.CholeskySolution(MTM, solution, MTV, size);

            double[] model = new double[targets.Count];
            for (int i = 0; i < model.Length; ++i)
            {
                model[i] = 0;
                for (int j = 0; j < solution.Length; ++j)
                {
                    model[i] += solution[j] * inputs[i][j];
                }
            }

            int right = 0;
            int cnt = 0;
            for (int i = 0; i < model.Length; ++i)
            {
                if (model[i] > 0 && targets[i] > 0) ++right;
                if (model[i] <= 0.0 && targets[i] <= 0.0) ++right;
                ++cnt;
            }
            Console.WriteLine("Linear model for training data. Right predictions = {0}, from {1}.", right, cnt);
        }
    }
}
