﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace bankchurn
{
    class Program
    {
        static void Main(string[] args)
        {
            DataHolder dh = new DataHolder();
            dh.PrepareBankChurnData();

            double targetMin = dh._targets.Min();
            double targetMax = dh._targets.Max();
            Console.WriteLine("Range for target = [{0:0.0000}, {1:0.0000}]\n", targetMin, targetMax);

            LinearModel lm = new LinearModel();
            lm.TestLinearModel(dh._inputs, dh._targets);
            Console.WriteLine();

            SingleU su = new SingleU();
            su.SingleUIdentification(dh._inputs, dh._targets, 12);
            su.AccuracyEstimation(dh._inputs, dh._targets);
            Console.WriteLine();

            //These two parameters define accuracy and complexity of the model.
            //They should be tuned for each data. Not too high and not too low.
            Console.WriteLine("\n----- Kolmogorov-Arnold model -----");
            int TermsInKolmogorovArnold = 3;
            Random rnd = new Random();
            KARNO ka = new KARNO(dh._clients, dh._targets);
            int folds = 10;
            for (int k = 0; k < folds; ++k)
            {
                Console.WriteLine("Step {0}, out of {1}", k + 1, folds);
                ka.MakeTrainTestSplit(k, folds);
                ka.GenerateInitialOperators(TermsInKolmogorovArnold, rnd);
                ka.ExecuteUpdateSteps(32);
                ka.FillModel();
            }
            ka.GetScore();
        }
    }
}
