﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace bankchurn
{
    class SingleU
    {
        private U _u = new U();
        public void SingleUIdentification(List<double[]> inputs, List<double> targets, int nx)
        {
            //find min, max
            int size = inputs[0].Length;
            double[] min = new double[size];
            double[] max = new double[size];
            for (int k = 0; k < size; ++k)
            {
                min[k] = inputs[0][k];
                max[k] = inputs[0][k];
            }
            foreach (double[] data in inputs)
            {
                for (int k = 0; k < size; ++k)
                {
                    if (data[k] < min[k]) min[k] = data[k];
                    if (data[k] > max[k]) max[k] = data[k];
                }
            }

            _u.Initialize(inputs[0].Length, nx, min, max);
            int steps = 32;
            for (int count = 0; count < steps; ++count)
            {
                for (int i = 0; i < inputs.Count; ++i)
                {
                    double[] data = inputs[i];
                    double diff = targets[i] - _u.GetU(data);
                    _u.Update(diff, data, 0.05);
                }
            }
        }

        public void AccuracyEstimation(List<double[]> inputs, List<double> targets)
        {
            int right = 0;
            double[] model = new double[targets.Count];
            int cnt = 0;
            for (int i = 0; i < targets.Count; ++i)
            {
                double[] data = inputs[i];
                model[i] = _u.GetU(data);
                ++cnt;

                if (model[i] > 0.0 && targets[i] > 0.0) ++right;
                if (model[i] <= 0.0 && targets[i] <= 0.0) ++right;
            }

            Console.WriteLine("Single Urysohn model for training data. Right predictions = {0}, from {1}.", right, cnt);
        }
    }
}
