﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace bankchurn
{
    class U
    {
        private List<PLL> _plist = new List<PLL>();
        private int _nt;

        public U()
        {
        }

        public int GetNumberOfLayers()
        {
            return _nt;
        }

        public void Clear()
        {
            _plist.Clear();
        }

        public double GetDerrivative(int layer, double x)
        {
            return _plist[layer].GetDerrivative(x);
        }

        public void Initialize(int nt, int nx, double[] xmin, double[] xmax)
        {
            _nt = nt;
            for (int i = 0; i < _nt; ++i)
            {
                _plist.Add(new PLL(nx, xmin[i], xmax[i]));
            }
        }

        public void Update(double y, double[] x, double mu)
        {
            y /= _nt;
            for (int i = 0; i < _nt; ++i)
            {
                _plist[i].Update(x[i], y, mu);
            }
        }

        public double GetU(double[] x)
        {
            double f = 0.0;
            for (int i = 0; i < _nt; ++i)
            {
                f += _plist[i].GetFunction(x[i]);
            }
            return f;
        }

        public void ShowOperator()
        {
            int nt = _plist.Count();
            int nx = _plist[0].GetNumberOfPoints();
            Console.WriteLine("-------------- Operator, time changes with row, level with column --------------");
            for (int i = 0; i < nt; ++i)
            {
                for (int j = 0; j < nx - 1; ++j)
                {
                    Console.Write("{0:0.00}, ", _plist[i].GetY(j));
                }
                Console.Write("{0:0.00}", _plist[i].GetY(nx - 1));
                Console.WriteLine();
            }
            Console.WriteLine("----------------------");
        }
    }
}
