﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace bankchurn
{
    //Ranges
    //350 850 score
    //0 2 country (enum)
    //0 1 gender (enum)
    //18 92 age
    //0 10 tenure
    //0 250898.09 balance
    //0 3 product (enum)
    //0 1 card (enum)
    //0 1 active (enum)
    //11.58 199992.48 salary

    class UBranch
    {
        PLL _score = null;
        double[] _country = null;
        double[] _gender = null;
        PLL _age = null;
        PLL _tenure = null;
        PLL _balance = null;
        double[] _product = null;
        double[] _card = null;
        double[] _activate = null;
        PLL _salary = null;

        public void Initialize()
        {
            _score = new PLL(6, 300.0, 900.0);
            _country = new double[3];
            _gender = new double[2];
            _age = new PLL(2, 10.0, 100.0);
            _tenure = new PLL(4, -1.0, 12.0);
            _balance = new PLL(3, 0.0, 300000.0);
            _product = new double[4];
            _card = new double[2];
            _activate = new double[2];
            _salary = new PLL(4, 0.0, 200000.0);
        }

        public void Update(client C, double delta, double mu)
        {
            delta /= 10.0;
            _score.Update(C.score, delta, mu);
            _country[C.country] += delta * mu;
            _gender[C.gender] += delta * mu;
            _age.Update(C.age, delta, mu);
            _tenure.Update(C.tenure, delta, mu);
            _balance.Update(C.balance, delta, mu);
            _product[C.product] += delta * mu;
            _card[C.card] += delta * mu;
            _activate[C.active] += delta * mu;
            _salary.Update(C.salary, delta, mu);
        }

        public double GetU(client C)
        {
            double f = 0.0;
            f += _score.GetFunction(C.score);
            f += _country[C.country];
            f += _gender[C.gender];
            f += _age.GetFunction(C.age);
            f += _tenure.GetFunction(C.tenure);
            f += _balance.GetFunction(C.balance);
            f += _product[C.product];
            f += _card[C.card];
            f += _activate[C.active];
            f += _salary.GetFunction(C.salary);
            return f;
        }
    }
}
